/*
 * label.c
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "label.h"

/*
 */

/* 文字列を保存する領域 */
static char string_tabel[LABEL_STRING_SIZE];

/* 文字列領域をどこまで利用しているかを指す */
static int	string_table_printer = 0;

/*
 */

static LabelPair label_table [ LABEL_TABLE_SIZE ];
static int	label_table_printer = 0;

/*
 * 既に登録済かどうかを確認する関数
 */

int search_label ( char *label ) {
  int i;

  /* リニアサーチ : 先頭から順番に探す */
  for ( i = 0; i < label_table_printer; i++ ) {
	if ( !strcmp ( label, label_table [ i ].name ) ) {
	  return i;
	}
  }

  return LABEL_NOT_FOUND;

}

/*
 *
 */

int set_label ( char *label, int addr ) {
  int i;
  
  if ( ( i = search_label ( label ) ) != LABEL_NOT_FOUND ) {
	/* 多重定義 */
	label_table [ i ].addr = addr;
  } else {
	/* 登録 */

	if ( label_table_printer + 1 < LABEL_TABLE_SIZE ) {
	  /* ラベルエリアの確保 */
	  i = label_table_printer++;
	  label_table [ i ].addr = addr;
	} else {
	  fprintf ( stderr, "Too may labels (no more label area)\n" );
	  exit ( -1 );
	}

	if ( string_table_printer + strlen ( label ) + 1 < LABEL_STRING_SIZE ) {
	  /* 文字列エリアの確保 */
		strcpy ( string_tabel + string_table_printer, label );
		label_table [ i ].name = string_tabel + string_table_printer;
		string_table_printer += strlen ( label ) + 1;
	} else {
	  fprintf ( stderr, "Too may labels (no more string area)\n" );
	  exit ( -1 );
	}
  }

  return i;
}

/*
 *
 */

int get_label ( char *label ) {
  int i;
  
  if ( ( i = search_label ( label ) ) == LABEL_NOT_FOUND ) {
	fprintf ( stderr, "Undefined labels(%s)\n", label );
	exit ( -1 );
  }

  return label_table [ i ].addr;

}

/*
 *
 */
