/*
 * label.h
 */

#ifndef	__LABEL_H_
#define	__LABEL_H_

/*
		どう実現するか
			文字列と値(整数値)の対応なので、
				set/get があればよい
					set : 上書きはなくてもよい(実現はする)
				<仕様>
						set : ラベル名と値を指定し、ラベル名の値を決める
						get : ラベル名を指定し、そのラベル名に対応する値を返す
						例外 : どれも、不適切だがサボろう
							(共通) 領域が足りなくなる
								error stop (本当はよくないが..)
							(set) 多重定義
								上書き
							(get) 未定義
								0 を返す
 */

/*
  方針:
		コンセプトコード : うごけばよい[効率は考えない]
		「動的メモリ確保」が望ましいが、面倒なので、後回し
			静的な領域を使う
 */

#define	LABEL_TABLE_SIZE	1000
#define	LABEL_STRING_SIZE	(LABEL_TABLE_SIZE*10)

/*
 */

#define	LABEL_NOT_FOUND	(-1)

/*
 */

typedef	struct	{
  char *name;
  int addr;
} LabelPair;

/*
 */

extern int search_label ( char *label );
extern int set_label ( char *label, int addr );
extern int get_label ( char *label );

/*
 */

#endif


