/*
 * test-003.c
 *		"Hello World" をメモリ上の文字列でやる
 */

#include <stdio.h>
#include "memory.h"
#include "instruction.h"
#include "cpu.h"

/*
 * main
 */

int main( int argc, char *argv[] ) {
  int memory[MEMORY_SIZE] = {
	/* 0 */ CPU_LDI, 0,			/* acc := 0 */
	/* 2 */ CPU_STM, 18,		/* [18] := acc */
	/* 4 */	CPU_LDI, 19,		/* acc := "Hello, World\n" のある場所 */
	/* 6 */ CPU_STX,			/* ix := acc */
	/* 7 */ CPU_LDXM,			/* acc := [ix] */
	/* 8 */	CPU_SUB, 18,		/* acc -= [18] */
	/* 10 */	CPU_JZ,	17,	/* if ( acc == 0 ) goto 17 */
	/* 12 */	CPU_LDXM,			/* acc := [ix] */
	/* 13 */	CPU_OUT,		/* putchar ( acc ) */
	/* 14 */	CPU_INCX,		/* ix ++ */
	/* 15 */	CPU_JUMP, 7,	/* goto 6 */
	/* 17 */	CPU_HALT,		/* END */
	/* 18 */	0,				/* ? */
	/* 19 */	'H',
				'e',
				'l',
				'l',
				'o',
				' ',
				'W',
				'o',
				'r',
				'l',
				'd',
				'\n',
				'\0',
  };
  CPU cpu;
  int debug = 0;

  if ( argc > 1 && !strcmp ( argv[1], "-d" ) ) {
	debug = 1;
  }

  init_cpu ( &cpu, 0 );

  execute ( &cpu, memory, debug );

  return 0;
}

